GNU bug report logs - #47566
28.0.50; diff-hl should use `repeat-mode' ... and not `smartrep'

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>; Done: Dmitry Gutov <dgutov@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 14 Apr 2021 19:56:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 14 15:56:54 2021
Received: from localhost ([127.0.0.1]:35797 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWld8-0003KD-LE
	for submit <at> debbugs.gnu.org; Wed, 14 Apr 2021 15:56:54 -0400
Received: from relay9-d.mail.gandi.net ([217.70.183.199]:44831)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lWld5-0003Jx-26
 for 47566 <at> debbugs.gnu.org; Wed, 14 Apr 2021 15:56:53 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay9-d.mail.gandi.net (Postfix) with ESMTPSA id 4FBFFFF803;
 Wed, 14 Apr 2021 19:56:41 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: =?iso-8859-1?Q?K=E9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
 <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
 <87czuzxysf.fsf@HIDDEN>
 <b5ee6bee-2535-899b-03d1-79d5f77a6b6d@HIDDEN>
 <874kg9mj7f.fsf@HIDDEN> <87h7k8n3uy.fsf@HIDDEN>
 <87tuo8of2g.fsf_-_@HIDDEN>
Date: Wed, 14 Apr 2021 22:52:28 +0300
In-Reply-To: <87tuo8of2g.fsf_-_@HIDDEN> (=?iso-8859-1?Q?=22K=E9vin?= Le
 Gouguec"'s message of "Wed, 14 Apr 2021 21:12:55 +0200")
Message-ID: <87im4or6df.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47566
Cc: 47566 <at> debbugs.gnu.org, Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

> Thanks!  Was this bit intentional?
>
>> ;;;###autoload
>> (put 'mode-line-defining-kbd-macro 'risky-local-variable t)

Thanks for noticing this, I stole this from bindings.el,
but now that repeat-echo-mode-line-string is highlighted
correctly in the mode-line, I wonder if such property is needed
for repeat-echo-mode-line-string at all?  And why it was needed
for mode-line-defining-kbd-macro to keep its text properties?

After removing this line from bindings.el:
  (put 'mode-line-defining-kbd-macro 'risky-local-variable t)
mode-line-defining-kbd-macro loses its text property
face=font-lock-warning-face, but repeat-echo-mode-line-string keeps it.

This is explained in (info "(elisp) Properties in Mode"),
but I don't understand why text properties are preserved for
repeat-echo-mode-line-string without ‘risky-local-variable’ property?

> Also, AFAICT the indication (whether in the mode-line or in the echo
> area) only shows up once I start repeating a key (e.g. after C-x o o),
> not when I first hit a repeatable key (e.g. after C-x o).

Strange, I see it immediately after C-x o.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 14 Apr 2021 19:13:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 14 15:13:06 2021
Received: from localhost ([127.0.0.1]:35743 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWkwk-0002H9-MO
	for submit <at> debbugs.gnu.org; Wed, 14 Apr 2021 15:13:06 -0400
Received: from mail-wr1-f47.google.com ([209.85.221.47]:40724)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1lWkwg-0002Gd-JC
 for 47566 <at> debbugs.gnu.org; Wed, 14 Apr 2021 15:13:04 -0400
Received: by mail-wr1-f47.google.com with SMTP id 12so20927381wrz.7
 for <47566 <at> debbugs.gnu.org>; Wed, 14 Apr 2021 12:13:02 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=WdysyFkFRI7lrdj3AWCHY6SUTPL4G0XAGBwDkCMFih4=;
 b=tCe1qgBl1tCRXdeMWLqddlEiRDAMc5lX9C4s7B3va07GVPA9xUtcU/Ahvo5ww+DbqW
 T2i54HA6gaIJo/+uzmf4S4GFWyqqFYDhvJCBhSPMDHNQQMluPrCyUxQH4LhqfMYgl5M9
 I/T5OH1ab2IjW0FuIxUj/gKQNMZyMGoKTmQaRxztdwgs3hXxsLe+G9eWT3JdlwtVeysJ
 PvMvzDiVkGEUYUxzqsZId6xTyhIwqQniUnxOwsYvAaZefbZxjdBXE6pEMsGs6tbBdGia
 gTBjxFEYfc6h/nJAQutddVmekB3cDBH425PwTLX05cEKeN8eAvymalbprQ04SE4TZyy7
 3uYQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=WdysyFkFRI7lrdj3AWCHY6SUTPL4G0XAGBwDkCMFih4=;
 b=qhOFqgrkGxbxv+RWCXMjVkT9Dueoj/u3vzgJDnbqsdqZds1czRoAkymg7YJbfr9RsR
 CJSWupdXiAy9q/UP8waCRD/TwRSJcwVpam7nALZiu1Jv4VWTchpAq4UhGEh0dSmejrFm
 DmbKq4riZH1kM2KjPUePXrl6CQ8w9ByMQvrw8jD5g8F9SeDmLcKbpgc4M7j3HQfObVz0
 KBpGzbksVMs7PgV9JweiV2pKcbYMzfz+2FGO3gHJySs0k0mk1xo5X6sJqdqCgbVEQYos
 97954zDCnOIEP3W7dDstILoM59Y2J4UVc67rkCelkv0JUkHGXC2lYzcNpbhUXbpBQTp4
 yh5Q==
X-Gm-Message-State: AOAM533RW/iHAUWCfGG645KztZ3Kw7iRuZ8IuGwrqYRccslYl8DPRtIK
 0172gZlaxsVepAdrQSpnONU=
X-Google-Smtp-Source: ABdhPJz7h8CSeWTyRVvRRp6E4zLE44XTQQ2HM3vDQ/a9ADDbAmCXeIe4o7fdWkiBzjyj7VxEoNKaeQ==
X-Received: by 2002:adf:d1ed:: with SMTP id g13mr29685049wrd.86.1618427576869; 
 Wed, 14 Apr 2021 12:12:56 -0700 (PDT)
Received: from my-little-tumbleweed ([2a01:e0a:20e:d340:922b:34ff:fe95:9aed])
 by smtp.gmail.com with ESMTPSA id
 f12sm291005wrr.61.2021.04.14.12.12.55
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 14 Apr 2021 12:12:56 -0700 (PDT)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
 <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
 <87czuzxysf.fsf@HIDDEN>
 <b5ee6bee-2535-899b-03d1-79d5f77a6b6d@HIDDEN>
 <874kg9mj7f.fsf@HIDDEN> <87h7k8n3uy.fsf@HIDDEN>
Date: Wed, 14 Apr 2021 21:12:55 +0200
In-Reply-To: <87h7k8n3uy.fsf@HIDDEN> (Juri Linkov's message of "Wed, 
 14 Apr 2021 21:10:12 +0300")
Message-ID: <87tuo8of2g.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47566
Cc: 47566 <at> debbugs.gnu.org, Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Juri Linkov <juri@HIDDEN> writes:

>> An entry in mode-line-modes, =C3=A0 la compilation-in-progress, would be
>> lovely IMO.
>
> compilation-in-progress is a good example of an unobtrusive indicator
> in the mode line.  Now added to repeat-mode.

Thanks!  Was this bit intentional?

> ;;;###autoload
> (put 'mode-line-defining-kbd-macro 'risky-local-variable t)

Also, AFAICT the indication (whether in the mode-line or in the echo
area) only shows up once I start repeating a key (e.g. after C-x o o),
not when I first hit a repeatable key (e.g. after C-x o).

Is this intended?  I figure it would make sense to display the
indication before the user starts repeating, since the indication can
serve as a warning that repetition might occur.


At any rate, thanks a lot for working on this.  (And thanks to all for
the addition to diff-hl!)


> PS: like your message-subject-re-regexp turned the subject into
> "Re: peat lambda" on emacs-devel, it removed the bug number
> from the subject here :)

=F0=9F=A4=A6 Thanks for the heads-up.  IIUC message-subject-re-regexp is us=
ed both
by Gnus summary buffers to "canonicalize" subjects in order to only show
them for thread roots, *and* by message-mode to strip cruft before
adding "Re:" to a reply.  I'll need to figure a way to decorrelate those
two uses=E2=80=A6

(This is completely off-topic of course; I'm just thinking out loud)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 14 Apr 2021 18:15:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 14 14:15:03 2021
Received: from localhost ([127.0.0.1]:35668 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWk2Z-00052n-Bl
	for submit <at> debbugs.gnu.org; Wed, 14 Apr 2021 14:15:03 -0400
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:33493)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lWk2U-00051s-NG
 for 47566 <at> debbugs.gnu.org; Wed, 14 Apr 2021 14:15:01 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay6-d.mail.gandi.net (Postfix) with ESMTPSA id 701E2C0002;
 Wed, 14 Apr 2021 18:14:50 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: =?iso-8859-1?Q?K=E9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
Subject: Re: bug#47566: 28.0.50;
 diff-hl should use `repeat-mode' ... and not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
 <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
 <87czuzxysf.fsf@HIDDEN>
 <b5ee6bee-2535-899b-03d1-79d5f77a6b6d@HIDDEN>
 <874kg9mj7f.fsf@HIDDEN>
Date: Wed, 14 Apr 2021 21:10:12 +0300
Message-ID: <87h7k8n3uy.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566
Cc: 47566 <at> debbugs.gnu.org, Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> Consider adding a repeat-mode-echo option which follows what Smartrep
>> does: instead of adding to the echo area, it just highlights the
>> changed state in the mode line (basically a long mode lighter saying
>> "========SMARTREP=======") and also colors the mode-line green.
>>
>> IME that works well as an indicator that we're in a "special" state.
>>
>> Though perhaps we could use a smaller text (like "[REPEAT]") and only
>> color the text inside the brackets, rather than the whole
>> mode-line. Could use some experimentation.
>
> An entry in mode-line-modes,  la compilation-in-progress, would be
> lovely IMO.

compilation-in-progress is a good example of an unobtrusive indicator
in the mode line.  Now added to repeat-mode.

PS: like your message-subject-re-regexp turned the subject into
"Re: peat lambda" on emacs-devel, it removed the bug number
from the subject here :)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 14 Apr 2021 07:14:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 14 03:14:21 2021
Received: from localhost ([127.0.0.1]:33236 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWZjB-0003xE-E2
	for submit <at> debbugs.gnu.org; Wed, 14 Apr 2021 03:14:21 -0400
Received: from mail-wm1-f48.google.com ([209.85.128.48]:46792)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1lWZj9-0003x1-At
 for 47566-done <at> debbugs.gnu.org; Wed, 14 Apr 2021 03:14:20 -0400
Received: by mail-wm1-f48.google.com with SMTP id
 z24-20020a1cf4180000b029012463a9027fso9947508wma.5
 for <47566-done <at> debbugs.gnu.org>; Wed, 14 Apr 2021 00:14:19 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=lvXqs9KUhRj//sfjKaYLg8k6Dl/dZBjLkasaVNRGKpg=;
 b=T0riJy9Rqg32THKT53G217Go+caY3lI8p53uj4+sovI939s6Fhwz6nbtu3iyZ6Z0SG
 sJRJtC4qix14bAMCyyGKs2P7i8VhWqfkFA+YgtcRZ99sCdTrtpRMo2632e3GC2HCH9i6
 Z61sx3SneiwkmkFz3TUei5ucYnLjqzTWod9Rmm0MD/ZY8JTNuA7kaifeKWsYBHqNrGjt
 cxKRN9c6Rsjs6fbcjLBvV6n/smEMRMFf4DcL4vNcflpmpwTQlv+XBLbNNyrKE6GfA/cX
 ASqmzaWALS23GxGpahC1JlP79MCiHQyU4GHB0dJViOoR6gaXmwN7MQjfxjIkfPRdEHvE
 pVeA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=lvXqs9KUhRj//sfjKaYLg8k6Dl/dZBjLkasaVNRGKpg=;
 b=PNWM1nGLf+L76k3An6rJDQRS9kHRbMXeT5pBZk38LfwkdVfoFNqaWiDyvwR/3OPooP
 JXD52dLTINUB90Y6F2HVGrwrZJel2w556VaX4/rD+bdaEOA4nnrcPETy8U2Sm6TRXBMH
 t6+lpcd/dkHAJKxLwTDDhJD5IbkNbfz+jrj8pZ5flyJLnHdesdcLZ6erqNtgsRo+Zgoo
 fjPqEqK8Ln56F6t5byaPR5+z9tG+hnmAuOlB/CdSqj0TQjUllopYbMKS1YxgkypXI6tq
 cgmR7kts6kure6S6xOsf2T5fmHxZMJQV7bfcmHEPCdTLD9HQXiCKHZ7VYk+bsccjpQV6
 E19g==
X-Gm-Message-State: AOAM5326O7WqWitLiCKo+aZp1BqyPxCU64oUmfDDWV6nNklxtboiICRv
 b5O8R/EtZE7RWhj9A9tkaQs=
X-Google-Smtp-Source: ABdhPJzobk8lsDbqfxqFm4L9g6ElCNFFQViAYsnvmf1owvx2DUKj+oUQ5XnB/LYxamANQBhj3f44hA==
X-Received: by 2002:a05:600c:154a:: with SMTP id
 f10mr1478959wmg.20.1618384453166; 
 Wed, 14 Apr 2021 00:14:13 -0700 (PDT)
Received: from my-little-tumbleweed ([2a01:e0a:20e:d340:922b:34ff:fe95:9aed])
 by smtp.gmail.com with ESMTPSA id
 y20sm4302199wma.45.2021.04.14.00.14.12
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 14 Apr 2021 00:14:12 -0700 (PDT)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: 28.0.50; diff-hl should use `repeat-mode' ... and not `smartrep'
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
 <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
 <87czuzxysf.fsf@HIDDEN>
 <b5ee6bee-2535-899b-03d1-79d5f77a6b6d@HIDDEN>
Date: Wed, 14 Apr 2021 09:14:12 +0200
In-Reply-To: <b5ee6bee-2535-899b-03d1-79d5f77a6b6d@HIDDEN> (Dmitry Gutov's
 message of "Wed, 14 Apr 2021 02:54:06 +0300")
Message-ID: <874kg9mj7f.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org,
 Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>,
 Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Dmitry Gutov <dgutov@HIDDEN> writes:

> Consider adding a repeat-mode-echo option which follows what Smartrep
> does: instead of adding to the echo area, it just highlights the
> changed state in the mode line (basically a long mode lighter saying
> "=3D=3D=3D=3D=3D=3D=3D=3DSMARTREP=3D=3D=3D=3D=3D=3D=3D") and also colors =
the mode-line green.
>
> IME that works well as an indicator that we're in a "special" state.
>
> Though perhaps we could use a smaller text (like "[REPEAT]") and only
> color the text inside the brackets, rather than the whole
> mode-line. Could use some experimentation.

An entry in mode-line-modes, =C3=A0 la compilation-in-progress, would be
lovely IMO.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 13 Apr 2021 23:54:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 13 19:54:16 2021
Received: from localhost ([127.0.0.1]:32980 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lWSrI-0001Rl-KP
	for submit <at> debbugs.gnu.org; Tue, 13 Apr 2021 19:54:16 -0400
Received: from mail-wr1-f45.google.com ([209.85.221.45]:46932)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1lWSrH-0001RY-RV
 for 47566-done <at> debbugs.gnu.org; Tue, 13 Apr 2021 19:54:16 -0400
Received: by mail-wr1-f45.google.com with SMTP id c15so9129167wro.13
 for <47566-done <at> debbugs.gnu.org>; Tue, 13 Apr 2021 16:54:15 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=/mPsu9ae8qQsISxGoMMLZl/8S6VSOyYQ8ykoQ2M0rIA=;
 b=izjKUpKLtlde5Nx9dt2WxrtaXWUZz7BQ+oN9bwAzHSLQqjj4S5xnLOtQCjVmt3y5ZN
 A5VPEa+VnpEPhXuTn1aD7NacfhdVXHNKejyMMBI2CWv0w0FymJkMTHVC6WvqSi4gNJU+
 DaWmPeJQKUCMAXWeBLzDB3idmmwTDAMN7y5Yko2ASLEGYqasQI8PJEBM2/84W/AwAnC0
 AU/aS+wjhUKEF8PWEgBERlJYPIHmxZAnuxbvRUxTfZtpff/a35vNWM56nEq//sH7zcXp
 dUQK7VcPAeOf3n/aEaOT6c5YmzeVB5l1bqTrNSnmmdUD7Hm1W7r5v7kBNk6qlZX2/oAf
 iGcQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=/mPsu9ae8qQsISxGoMMLZl/8S6VSOyYQ8ykoQ2M0rIA=;
 b=YBr5hP7WArRsW4+hpyZr8M+eakRNdXdkHMZDbbSRdYrZ6dkjiPkOMr1a+E0kM78yu4
 HPm2mKVeoZJMSFI8T64oBM4IlTPB/vM6Ai7feCT+UGvvVOmYOtV10LedVlJ8ewdv0lhv
 gwsTizHstrhSuxCivrQPbMiOmNaa4bDd/v2RzkQ8Ex8+RpIdiEkpKzzXXYLR/1RCt1Jz
 hzBPzTABbrH7lijjMvhx4BoHP7YDIiuQ5ORv3NYt2Gs7LkP1Y04MMKmPk1vbiOd+yyCD
 2TmC+OWJ0wsfuo3sagJC3bu4oKqo/FYLstewV7TG8xttfyKNJxDvDbe2/E2erFZguq43
 vIJA==
X-Gm-Message-State: AOAM531guigyvEb5yqONbq82vML9cZ+42UcOV4qx0Ig5aH/cwxGuluYz
 XnvlAbgq0waIHqH8UWrwCUM=
X-Google-Smtp-Source: ABdhPJylObzSaWeTTTPYJeQ5l1Th7EWQc58frKUuuvSjB+F0ufmxPmXMsJmchkMZ2VznyDUDwXSZiQ==
X-Received: by 2002:adf:f04d:: with SMTP id t13mr14872513wro.52.1618358049905; 
 Tue, 13 Apr 2021 16:54:09 -0700 (PDT)
Received: from [192.168.0.6] ([46.251.119.176])
 by smtp.googlemail.com with ESMTPSA id v189sm4434206wmg.9.2021.04.13.16.54.08
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 13 Apr 2021 16:54:08 -0700 (PDT)
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Juri Linkov <juri@HIDDEN>
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
 <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
 <87czuzxysf.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <b5ee6bee-2535-899b-03d1-79d5f77a6b6d@HIDDEN>
Date: Wed, 14 Apr 2021 02:54:06 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
In-Reply-To: <87czuzxysf.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org,
 Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 12.04.2021 19:17, Juri Linkov wrote:
>>> I can't find the face named 'deemphasized'.
>>
>> Sorry.
>>
>> Apparently, it's a face that only the tango-plus theme defines (unwisely).
>>
>> It simply looks like less contrasting text. Try 'shadow' instead, it's
>> about the same.
> 
> I'm not sure about deemphasizing by default.  But now it's easy to
> customize this, and add any emphazing.

Thanks.

Consider adding a repeat-mode-echo option which follows what Smartrep 
does: instead of adding to the echo area, it just highlights the changed 
state in the mode line (basically a long mode lighter saying 
"========SMARTREP=======") and also colors the mode-line green.

IME that works well as an indicator that we're in a "special" state.

Though perhaps we could use a smaller text (like "[REPEAT]") and only 
color the text inside the brackets, rather than the whole mode-line. 
Could use some experimentation.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 12 Apr 2021 16:18:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 12 12:18:42 2021
Received: from localhost ([127.0.0.1]:57835 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVzGs-0003WC-1v
	for submit <at> debbugs.gnu.org; Mon, 12 Apr 2021 12:18:42 -0400
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:34533)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lVzGo-0003VY-O0
 for 47566-done <at> debbugs.gnu.org; Mon, 12 Apr 2021 12:18:41 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 28DA42000E;
 Mon, 12 Apr 2021 16:18:29 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
 <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
Date: Mon, 12 Apr 2021 19:17:36 +0300
In-Reply-To: <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN> (Dmitry Gutov's
 message of "Sun, 11 Apr 2021 02:27:04 +0300")
Message-ID: <87czuzxysf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org,
 Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> I can't find the face named 'deemphasized'.
>
> Sorry.
>
> Apparently, it's a face that only the tango-plus theme defines (unwisely).
>
> It simply looks like less contrasting text. Try 'shadow' instead, it's
> about the same.

I'm not sure about deemphasizing by default.  But now it's easy to
customize this, and add any emphazing.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 12 Apr 2021 16:18:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 12 12:18:36 2021
Received: from localhost ([127.0.0.1]:57832 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVzGl-0003Vu-RM
	for submit <at> debbugs.gnu.org; Mon, 12 Apr 2021 12:18:36 -0400
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:32837)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lVzGk-0003VT-HJ
 for 47566-done <at> debbugs.gnu.org; Mon, 12 Apr 2021 12:18:35 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay6-d.mail.gandi.net (Postfix) with ESMTPSA id C1B0BC000C;
 Mon, 12 Apr 2021 16:18:26 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <TY2PR0101MB3693B8D2A7414F54CF71208FDA729@HIDDEN>
 <87lf9p91g8.fsf@HIDDEN>
 <TY2PR0101MB36939C0C2EE217BC28FB7023DA719@HIDDEN>
Date: Mon, 12 Apr 2021 19:16:38 +0300
In-Reply-To: <TY2PR0101MB36939C0C2EE217BC28FB7023DA719@HIDDEN>
 (Ramesh Nedunchezian's message of "Sun, 11 Apr 2021 12:18:43 +0530")
Message-ID: <87k0p7xyu1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org, Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> For those who don't want hints, they can use
>
>     (setq repeat-mode-helper #'ignore)
>
> For those who want hints, but do /not/ want the hints hogging the echo
> area, they could have their own custom helper like the one above,
> after replacing
>
> 	(message mess)
>
> with
>
> 	(tooltip-show mess)

This is implemented now, so you can customize it to disable messaging,
to do truncation of long messages, or to use tooltip-show, etc.

> I would also appreciate if you could assess adding the exit key as a
> property to the repeat mode symbol.

The exit key specific to some keymap can be easily added to that keymap.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 11 Apr 2021 23:12:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 11 19:12:54 2021
Received: from localhost ([127.0.0.1]:56024 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVjGA-0004KG-Lj
	for submit <at> debbugs.gnu.org; Sun, 11 Apr 2021 19:12:54 -0400
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:52389)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lVjG8-0004K0-2D
 for 47566-done <at> debbugs.gnu.org; Sun, 11 Apr 2021 19:12:52 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id 2A8DD60002;
 Sun, 11 Apr 2021 23:12:43 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <TY2PR0101MB3693B8D2A7414F54CF71208FDA729@HIDDEN>
 <87lf9p91g8.fsf@HIDDEN>
 <TY2PR0101MB36939C0C2EE217BC28FB7023DA719@HIDDEN>
Date: Mon, 12 Apr 2021 01:51:53 +0300
In-Reply-To: <TY2PR0101MB36939C0C2EE217BC28FB7023DA719@HIDDEN>
 (Ramesh Nedunchezian's message of "Sun, 11 Apr 2021 12:18:43 +0530")
Message-ID: <877dl84ds6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org, Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> This is what I was suggesting:
>
>     (defvar repeat-mode-helper
>       (defun repeat-mode-helper (map)
>[...]
>
> For those who don't want hints, they can use
>
>     (setq repeat-mode-helper #'ignore)

Thanks, this is a good idea.  Maybe the name is not the best one
since the word "helper" often means a place that provides some
utility functions.

Using the Emacs terminology, a better name would be 'repeat-mode-echo'.
I'll add such option soon.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 11 Apr 2021 06:49:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 11 02:49:12 2021
Received: from localhost ([127.0.0.1]:53857 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVTuB-0000v4-Ry
	for submit <at> debbugs.gnu.org; Sun, 11 Apr 2021 02:49:12 -0400
Received: from mail-oln040092254072.outbound.protection.outlook.com
 ([40.92.254.72]:2592 helo=APC01-PU1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rameshnedunchezian@HIDDEN>) id 1lVTu9-0000um-H0
 for 47566-done <at> debbugs.gnu.org; Sun, 11 Apr 2021 02:49:10 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=iKI5GxFzjvByQYMf049R6xJGFAHXQzr9APZUFR8rwVIFTWFsgHRoOEl2pAkoXLlXA4ZJV/ysHyGs9WIwLrz0+6kWXomsoig2daRrAxO1xY9EFxsMJcCynQTjP6sYQsENK15fIqcOkDkf37jdE/lOKeaFyU54At4lyHrPjUqYjboCawv1lhtHPdcibDRtkylnRw1s4j79nPWMRH1NN0FXE9rGJ5MrhfrKaf3OYibo+mITxPi98fOFUYfdSdqO0bsx2RZalsXvUCiaOYj6o26qOnA4fdIjoQW+dx4hTcb0DM7EqBr2+ZLoTwT9+IbeHWybB6uZ4bu6R0jYr0EmvkaB3Q==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=BqNIvSprHrBeuZxF2G6499spN9nxYw12OahMQpmaeV4=;
 b=elZNUPsnHQOkYGTtONQWHea4gG1GR5B6yOHdTqvz3QvEyRcIOv4Z8kPJMwAD0beTDf+HjOwYnEFRuVP93T7qg3xzOsM7ua+X0j/xYX77KGuBo6NI8VlbtUEEclduPN+P8+FCUfXQzNAW/t3tzZGL10vbAiYTh82OQfc+a+lSMUb0/6j3kNHb7uFkCpBIZvJNWZE9sZt1A/voU0c4vBMBa69pUzSaRHbVTywOFC+j9caDhGQQ7TPJz4yTcYJf1GisB6Kn9LO7gFhS/3MlpVv2vbXEC69xwneoUdROs6XQ4sn0wEffyh4P18ILkNe6GWJ1MOprSvi8Q5L8reGKD10Rrg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=BqNIvSprHrBeuZxF2G6499spN9nxYw12OahMQpmaeV4=;
 b=KvkB7G5VB343p6Ee4ta81YkBQwCWfvTkmypM1phXcpQlNMGaBL/xHwQh9oxPx/NMGA4vcNzwqSfxL13VOLU26Nvqt2zp1d0uWPiW/xOt05bYwV1J2eqdHRi/obf4VV2XwJk6skrauHUQ4NwhZg9zMQ8VO2fpVBOPYTmNL62n9Qc9TjjeetlJ9TpIeWg+oAPVDGFqL9DgoPBhRZsiPHcRK7EijaANCQbptAolatqufYhfJHYH8ces7iDwbZL/GTBut1C9EcoCpfcFeyDV8d0d/fGL+CJwE98T4wqkeUebuLKZk9RkDXOU266KZ0kcnZnmwAYCIRMDFJoS58EgteLlfA==
Received: from TY2PR0101MB3693.apcprd01.prod.exchangelabs.com (20.180.79.144)
 by TYZPR01MB3854.apcprd01.prod.exchangelabs.com (20.182.177.69) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4020.17; Sun, 11 Apr
 2021 06:48:52 +0000
Received: from TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 ([fe80::4980:4d7f:474b:de2c]) by
 TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 ([fe80::4980:4d7f:474b:de2c%3]) with mapi id 15.20.4020.022; Sun, 11 Apr 2021
 06:48:52 +0000
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Juri Linkov <juri@HIDDEN>
Newsgroups: gmane.emacs.bugs
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <TY2PR0101MB3693B8D2A7414F54CF71208FDA729@HIDDEN>
 <87lf9p91g8.fsf@HIDDEN>
From: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
Message-ID: <TY2PR0101MB36939C0C2EE217BC28FB7023DA719@HIDDEN>
Date: Sun, 11 Apr 2021 12:18:43 +0530
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.5.0
In-Reply-To: <87lf9p91g8.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-TMN: [QXFQtxR/mjE0QomgtFepciP43gefT+31cs2oy06QCdUwOI+5faIzh61GW2PVwhTD]
X-ClientProxiedBy: MA1PR0101CA0055.INDPRD01.PROD.OUTLOOK.COM
 (2603:1096:a00:20::17) To TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 (2603:1096:404:800f::16)
X-Microsoft-Original-Message-ID: <3a04f0c2-0a7d-2832-a896-a7edef328c88@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from [IPv6:2401:4900:331e:970e:92f:5561:116:88b0]
 (2401:4900:331e:970e:92f:5561:116:88b0) by
 MA1PR0101CA0055.INDPRD01.PROD.OUTLOOK.COM (2603:1096:a00:20::17) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4020.16 via Frontend
 Transport; Sun, 11 Apr 2021 06:48:51 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: b64e6902-d4ae-4bca-9ac7-08d8fcb5de82
X-MS-TrafficTypeDiagnostic: TYZPR01MB3854:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: P2PbqWYk13J4tQpdlFU9I3m0+0fM+7ki/apYN/7QsLEOHNzDgaW4nVep1vcQuQ7O2Gy27iWg2PL2uk2224qFwc6gqXMksrJr7mPHSksBzmLir16iAw0CLFISqFCJvsGIPi3820O5agCYOlnxpHT1JQaIumEyYsZUhnAxhh1FYeQpAsknGvS/zFJzma5qb9GV71icSJmcVJwgbt3/sQHwfOUmRzbfe1L+Ey12dbyeFFJhslyomOlVBXfxY/3IjkXWWN3dERnWGu4Xbjeo9pIgUfpHAhglmZanuwNAslfRr0rWLfTzNliQO+USELKezLtIatCKNuI4tY7TcVqskgQ4etBnh7D3vp8JxieCXsbYVAe0650hc6cYesuUt7PspK8O4JQpKhIyXv2kG5OH3U7jEQ==
X-MS-Exchange-AntiSpam-MessageData: 6wved4knKvB3qJF2Q/Q3pqzFIk90Tl2KFftHFcvFFqKl+mvAWAnvrzt6zjfVh95VqN9Nql5y2oZIZBpePpeCbI/20adjtvGYIog/XiLlUSGRT4uRg50twX2LcBWQWoY5ytf3J2KdUWzQClYB/HE1XBMKY8mgmpdJdcznNBdLNMG2lKWcSBxN6chwZAWMvek7CWmiHUP4B1r2i8pwuRl9Bw==
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: b64e6902-d4ae-4bca-9ac7-08d8fcb5de82
X-MS-Exchange-CrossTenant-AuthSource: TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 11 Apr 2021 06:48:52.8293 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: TYZPR01MB3854
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 11/04/21 4:29 am, Juri Linkov wrote: >> It seems to me
 that repeat-mode is essentially a poor man's hydra. > > It is. It provides
 only the basic functionality. > Don't expect many fancy things from [...]
 Content analysis details:   (1.6 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [40.92.254.72 listed in list.dnswl.org]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (rameshnedunchezian[at]outlook.com)
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [40.92.254.72 listed in wl.mailspike.net]
 0.0 MSGID_FROM_MTA_HEADER  Message-Id was added by a relay
 -0.0 NICE_REPLY_A           Looks like a legit reply (A)
 1.6 FORGED_MUA_MOZILLA     Forged mail pretending to be from Mozilla
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.6 (/)


On 11/04/21 4:29 am, Juri Linkov wrote:
>> It seems to me that repeat-mode is essentially a poor man's hydra.
> 
> It is.  It provides only the basic functionality.
> Don't expect many fancy things from repeat-mode.

The code below is pulled out from the existing code i.e., it doesn't
add any additional layer of complexity or does anything fanciful.  But
it does add a bit of extensibility.

This is what I was suggesting:

    (defvar repeat-mode-helper
      (defun repeat-mode-helper (map)
	(let (keys)
	  (message "Coming here")
	  (map-keymap (lambda (key _) (push key keys)) map)
	  (let ((mess (format-message
		       "Repeat with %s%s"
		       (mapconcat (lambda (key)
				    (key-description (vector key)))
				  keys ", ")
		       (if repeat-exit-key
			   (format ", or exit with %s"
				   (key-description repeat-exit-key))
			 ""))))
	    (if (current-message)
		(message "%s [%s]" (current-message) mess)
	      (message mess))))))


And in `repeat-post-hook', do something like

    ;; Messaging
    (unless prefix-arg
      (funcall (or (get rep-sym 'help) repeat-mode-helper) rep-map))


For those who don't want hints, they can use

    (setq repeat-mode-helper #'ignore)

For those who want hints, but do /not/ want the hints hogging the echo
area, they could have their own custom helper like the one above,
after replacing

	(message mess)

with

	(tooltip-show mess)

--------------------------------

I would also appreciate if you could assess adding the exit key as a
property to the repeat mode symbol.






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 10 Apr 2021 23:27:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 10 19:27:15 2021
Received: from localhost ([127.0.0.1]:53555 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVN0V-0006Ua-CU
	for submit <at> debbugs.gnu.org; Sat, 10 Apr 2021 19:27:15 -0400
Received: from mail-ej1-f49.google.com ([209.85.218.49]:39465)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1lVN0T-0006UN-HW
 for 47566-done <at> debbugs.gnu.org; Sat, 10 Apr 2021 19:27:13 -0400
Received: by mail-ej1-f49.google.com with SMTP id v6so13022883ejo.6
 for <47566-done <at> debbugs.gnu.org>; Sat, 10 Apr 2021 16:27:13 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=5oEbNQJGx6i0FbAfX0GYxlf/CytqucwKPZSJgAd27QI=;
 b=bR2ODYGJ7BktNkY+CjUA/+wLaq4VBACvSgbK+v1c6TiYBn7I9E98Cl4dFUb6TlfHsv
 JXbJ1L94SkToD1soVz6/xMpHQ+iua9YySYLklUOpdZnDHVfVTG1iG8bLsL2zToDANc1U
 TfAIPpuGtQgZMKzuFzgJnThkgJupYimLeZmTlmZyBy5t4orQ0PIXMJnUDn9IDqKUGmqC
 w61gndQbx3L+7rm2VOTlPpjRvWTtFnkbkHA6NUHJNWPUnxaCc+Z6mfixYS6Tql29Uo53
 A+urWFhlU0C2RthVNgrl5+t3p4kqp78jwEaJ/OhL9BbpquVyb7CMBDPQK64WtSMidmWG
 JP4w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=5oEbNQJGx6i0FbAfX0GYxlf/CytqucwKPZSJgAd27QI=;
 b=OkMj2S+m63NTYbMh8ngJcKEtJ/t4AWVnQowGeef7JhN1dltG7JFsznxb+20NJAVzQI
 auUNW7d3RwruLdWsQr0LsC4in7XpstTrAbeiXkiZWJxo2hXw/kIfYE87mwMa7EklZfdJ
 l5u8gO4Ubn251HLuwyHQzHVvK9q9mZ+wWyvUhSa+qcHCBxAa31xtf65BezZRvP+WY88H
 8ygFsjQzMY2ymsgFt/01HC6MKKt2AqCDHjHSxDa+Abo1O2Rrlu7/N6t57H/Hy6WqZ688
 rGrvPsiNGz/0N2rz7+huRSMY4rEl+bQlT3Ez5xT/R+nn0/EaT2KMCYD9oBhy6gS0Y242
 8YsQ==
X-Gm-Message-State: AOAM5315j1vFfLs/H+2tOJOBjNVMDBGkmr8iw82wDFysfn7QXlRfDfzP
 98DN/aCVNKbjYu2OUthk5jo=
X-Google-Smtp-Source: ABdhPJw8S626nSZJR/4WGDC+/50XKX2nUjMIJ1Fb2T3bTKv4/pgCO0ddd/NYQWyDBugkYRHDwASUlA==
X-Received: by 2002:a17:906:c290:: with SMTP id
 r16mr2575276ejz.241.1618097227583; 
 Sat, 10 Apr 2021 16:27:07 -0700 (PDT)
Received: from [192.168.0.6] ([46.251.119.176])
 by smtp.googlemail.com with ESMTPSA id x1sm3244710eji.8.2021.04.10.16.27.05
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Sat, 10 Apr 2021 16:27:06 -0700 (PDT)
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Juri Linkov <juri@HIDDEN>
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <87eefh9176.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <5c7b677f-0f4a-bbef-8c1f-42cd024c7314@HIDDEN>
Date: Sun, 11 Apr 2021 02:27:04 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
In-Reply-To: <87eefh9176.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org,
 Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 11.04.2021 01:58, Juri Linkov wrote:
> I can't find the face named 'deemphasized'.

Sorry.

Apparently, it's a face that only the tango-plus theme defines (unwisely).

It simply looks like less contrasting text. Try 'shadow' instead, it's 
about the same.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 10 Apr 2021 23:22:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 10 19:22:10 2021
Received: from localhost ([127.0.0.1]:53550 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVMvZ-0006N4-Om
	for submit <at> debbugs.gnu.org; Sat, 10 Apr 2021 19:22:09 -0400
Received: from relay2-d.mail.gandi.net ([217.70.183.194]:47907)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lVMvX-0006MO-E3
 for 47566-done <at> debbugs.gnu.org; Sat, 10 Apr 2021 19:22:08 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay2-d.mail.gandi.net (Postfix) with ESMTPSA id 9F23640005;
 Sat, 10 Apr 2021 23:21:59 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
 <TY2PR0101MB3693B8D2A7414F54CF71208FDA729@HIDDEN>
Date: Sun, 11 Apr 2021 01:59:47 +0300
In-Reply-To: <TY2PR0101MB3693B8D2A7414F54CF71208FDA729@HIDDEN>
 (Ramesh Nedunchezian's message of "Sat, 10 Apr 2021 14:08:50 +0530")
Message-ID: <87lf9p91g8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org, Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> It seems to me that repeat-mode is essentially a poor man's hydra.

It is.  It provides only the basic functionality.
Don't expect many fancy things from repeat-mode.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 10 Apr 2021 23:22:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 10 19:22:05 2021
Received: from localhost ([127.0.0.1]:53547 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lVMvV-0006Mm-IL
	for submit <at> debbugs.gnu.org; Sat, 10 Apr 2021 19:22:05 -0400
Received: from relay4-d.mail.gandi.net ([217.70.183.196]:39485)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lVMvU-0006MG-2k
 for 47566-done <at> debbugs.gnu.org; Sat, 10 Apr 2021 19:22:04 -0400
X-Originating-IP: 91.129.96.157
Received: from mail.gandi.net (m91-129-96-157.cust.tele2.ee [91.129.96.157])
 (Authenticated sender: juri@HIDDEN)
 by relay4-d.mail.gandi.net (Postfix) with ESMTPSA id A947AE0003;
 Sat, 10 Apr 2021 23:21:55 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
Date: Sun, 11 Apr 2021 01:58:13 +0300
In-Reply-To: <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN> (Dmitry Gutov's
 message of "Sat, 10 Apr 2021 04:40:49 +0300")
Message-ID: <87eefh9176.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org,
 Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Maybe something like this would be an improvement? Experimental
> code warning.
>
> diff --git a/lisp/repeat.el b/lisp/repeat.el
> index b3c58f2f81..e704e4da56 100644
> --- a/lisp/repeat.el
> +++ b/lisp/repeat.el
> @@ -404,7 +404,7 @@ repeat-post-hook
>                                         (key-description repeat-exit-key))
>                               ""))))
>                  (if (current-message)
> -                    (message "%s [%s]" (current-message) mess)
> +                    (message #("%s [%s]" 3 7 (face deemphasized)) (current-message) mess)

I can't find the face named 'deemphasized'.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 10 Apr 2021 08:39:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 10 04:39:19 2021
Received: from localhost ([127.0.0.1]:51406 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lV99C-0005X9-Qg
	for submit <at> debbugs.gnu.org; Sat, 10 Apr 2021 04:39:19 -0400
Received: from mail-oln040092253035.outbound.protection.outlook.com
 ([40.92.253.35]:6120 helo=APC01-SG2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rameshnedunchezian@HIDDEN>) id 1lV99A-0005Wt-K8
 for 47566-done <at> debbugs.gnu.org; Sat, 10 Apr 2021 04:39:17 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=CNaXBF4lZEkINEuDvU3IFH2W1T0oKzVQaXoF6Vp2fga6BuWFnvvoOETKygYQMA0hRwjAo65YQ182QKAo/jQlwSQp0D9ukGfMAX/m0zI6b7KkzW8EATrpBY7xt6H90GtQ7YdZNUOxddMU0jQzC+NDxl+DPQT32Cu4/x178Om4o3NORPhXY0RGUkXskbeCz8EKwIRLu6TpsGKtkO6SNtEQ0aqIHS+VTfRl8abvm2F4I9rjL5Oq4gN5u8lee6YwFnp5ozelHQrmbur6zDQq9V59LLVymlajEFxZdEVFJPOnrBTIX66BTOQ2egLZk2QQ/KTGNgYiXpSXNcPZyj1ZQ+UeRQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=zoWWqWtRPD6MNtC8dxbCu1Y/jU73pt4Q0Gt6k7vMYEU=;
 b=XMmm0bOQ0pUtg2kX3BsdTmIH9pR4Wn/l5ASuY/u7OrRi+YdlN0yG1tEPeQrfTRp4wWf9NQaUoMHSILTV3KRgRGVJyjJmzaNqadX8x1xdBJIn03bOtawu3oz849qZpJy9u4HJNWXrzZu7Y1zQicgN5aVJb4qIQT1jCod13UTiZcjO3YCxc35JowTOQP/09CV2gHx9O99gi+Jb2oXB2Xmg+s24eN8W+XAQkK362qLcNeS1RtLt3IN4wJ14KEP+grWvFI9M7eFcvCYM9RnYO+6dypbfRzu4u0By+Va8qTka/k/RQppszepV3Fxo/1Msd7Vyb6raCaHoRMLTMAQPVzhbcQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=zoWWqWtRPD6MNtC8dxbCu1Y/jU73pt4Q0Gt6k7vMYEU=;
 b=CDdPSMxdd84azpYl4m0BXawDhNsd9P+Mv3ZzJmz0zsPHXcnbF0L+eWgiHWX8Gvtyh38GTPPHPkcZng7HqhwFZuy7sfbZDwdqAhcCauYZLb5etXuRJjVBkwWN/yuH22Bhve8fqTGsAy3YG+qC8V9uV8bc4IGjz4MbV+tkG1f9KYKVEjI2h0Y3wW2Wo6nDZ3Cm6+Sjs2z9oaXMBFDoY+jwXZ+/ca7LkRpb75qf+32V+ZPx37CEO261rFws+/hDExxoNDIDx75MORVOBz8rOC0HBHkHH0oO0+wJTSd+KvSOM8sEsQRPwmBiBr60QaSrMSGmk7iN4JVBUTBTwbRwVW/6UQ==
Received: from TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 (2603:1096:404:800f::16) by TYZPR01MB4015.apcprd01.prod.exchangelabs.com
 (2603:1096:400:3e::10) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4020.17; Sat, 10 Apr
 2021 08:39:02 +0000
Received: from TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 ([fe80::4980:4d7f:474b:de2c]) by
 TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 ([fe80::4980:4d7f:474b:de2c%3]) with mapi id 15.20.4020.018; Sat, 10 Apr 2021
 08:38:56 +0000
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Dmitry Gutov <dgutov@HIDDEN>, Juri Linkov <juri@HIDDEN>
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
 <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
From: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
Message-ID: <TY2PR0101MB3693B8D2A7414F54CF71208FDA729@HIDDEN>
Date: Sat, 10 Apr 2021 14:08:50 +0530
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.5.0
In-Reply-To: <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-TMN: [ouGSFi3SBeiSy3gUQ2cWCYrtzfGv59+7vGgjD24v9wbt3fTXvSi8oGP3tJ9AVMULk/S+5eLQw4w=]
X-ClientProxiedBy: MAXPR0101CA0035.INDPRD01.PROD.OUTLOOK.COM
 (2603:1096:a00:d::21) To TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 (2603:1096:404:800f::16)
X-Microsoft-Original-Message-ID: <5bb41686-fa49-3e7f-2bb4-571df9019e47@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from [IPv6:2401:4900:330d:5d93:fc95:fa5e:bce5:8b48]
 (2401:4900:330d:5d93:fc95:fa5e:bce5:8b48) by
 MAXPR0101CA0035.INDPRD01.PROD.OUTLOOK.COM (2603:1096:a00:d::21) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4020.16 via Frontend
 Transport; Sat, 10 Apr 2021 08:38:55 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: bdb8c24e-db7e-4db9-2bf5-08d8fbfc1450
X-MS-TrafficTypeDiagnostic: TYZPR01MB4015:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: AdygAaZL+6P6mdwdqwnxnKSTVmfWoP9834UPloVaO3lA5QiwKNNDOEgE2EN8M/0k+O9fOwNslnfNro4JmMQ5coYOpry/4W5xiVa12fGUCg5PN+uyyhgO3GeUVsWtwNN0D/FzEZYlq77WO8xBrd+HpyaDOOwXygsn1NYsQGvtfXORgS+vk2tePjT7ISi2Z/KgiXiZ39tXhi/VRgaXBfbogk1sHKy/e1JX3xXFdqtMvk5c8173e7oZTsvuv1kHJlqLvuSqA8fnV7UgKkGBek1yFBmg4x2bLL8MoepIHttaVsnsK5hJs3/wY5BtsNDJ/ieWFCXWGUMLuwOw3PgeH2/5aWy/w4+Fs013Tjzcp+O2fCMhAk8BNOfvMpTj+0o/W6KxylU58aMY07luxw77PHbWlnMwJ+ve4J/4mWWSZbNI9xezAYOqibqPaUHXNpkJK7z3
X-MS-Exchange-AntiSpam-MessageData: /+XWVzHJzHoTrjUANRNFUNlI6Wl46wuRYv63WH2c/OXR/tiZ0G1s0tj6PUotRC56pc07bOEyN4vjPmTOWSrkM98vNQwzKs3d9t35ezFmn3/ez21Rl3V6cqGnD/9Xfl1KHFfvgUVJ4MSUsZx8F9PFNmGoLecyq3Tc42CVTRqEknaMbFmqkwooptpvKTc7un85rueK2wOmt26wAfeOo++a+Q==
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: bdb8c24e-db7e-4db9-2bf5-08d8fbfc1450
X-MS-Exchange-CrossTenant-AuthSource: TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 10 Apr 2021 08:38:56.7120 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: TYZPR01MB4015
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 10/04/21 7:10 am, Dmitry Gutov wrote: > (*) Though the
 first impression, in comparison, was that it is too chatty. The hints are
 definitely helpful for discovery at first, though. > > Maybe something like
 this would be an improvement? Exp [...] 
 Content analysis details:   (1.6 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [40.92.253.35 listed in list.dnswl.org]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (rameshnedunchezian[at]outlook.com)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [40.92.253.35 listed in wl.mailspike.net]
 0.0 MSGID_FROM_MTA_HEADER  Message-Id was added by a relay
 -0.0 NICE_REPLY_A           Looks like a legit reply (A)
 1.6 FORGED_MUA_MOZILLA     Forged mail pretending to be from Mozilla
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.6 (/)



On 10/04/21 7:10 am, Dmitry Gutov wrote:

> (*) Though the first impression, in comparison, was that it is too chatty. The hints are definitely helpful for discovery at first, though.
> 
> Maybe something like this would be an improvement? Experimental code warning.
> 
> diff --git a/lisp/repeat.el b/lisp/repeat.el
> index b3c58f2f81..e704e4da56 100644
> --- a/lisp/repeat.el
> +++ b/lisp/repeat.el
> @@ -404,7 +404,7 @@ repeat-post-hook
>                                         (key-description repeat-exit-key))
>                               ""))))
>                  (if (current-message)
> -                    (message "%s [%s]" (current-message) mess)
> +                    (message #("%s [%s]" 3 7 (face deemphasized)) (current-message) mess)
>                    (message mess))))
> 
>              ;; Adding an exit key

I created a repeat map for rectangle commands, and the echo area
becomes much more chattier. See
https://debbugs.gnu.org/cgi/bugreport.cgi?bug=47688.

It seems to me that repeat-mode is essentially a poor man's hydra.
May be the the symbol that holds the repeat map can specify a
`:help'-er property.

This `:help'-er can either

(a) give a fancy help string which the `repet-mode' can display in a
    pop-up

or

(b) the helper itself can prepare the string and arrange for providing
    a pop-up.

What I am saying is let the repeat map provide it's own `:help'-er
which the `repeat-mode' can hook in to.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566-done <at> debbugs.gnu.org:


Received: (at 47566-done) by debbugs.gnu.org; 10 Apr 2021 01:40:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 09 21:40:58 2021
Received: from localhost ([127.0.0.1]:51191 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lV2cM-0003oj-Lu
	for submit <at> debbugs.gnu.org; Fri, 09 Apr 2021 21:40:58 -0400
Received: from mail-wr1-f46.google.com ([209.85.221.46]:38672)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1lV2cL-0003oX-FC
 for 47566-done <at> debbugs.gnu.org; Fri, 09 Apr 2021 21:40:57 -0400
Received: by mail-wr1-f46.google.com with SMTP id w4so3532912wrt.5
 for <47566-done <at> debbugs.gnu.org>; Fri, 09 Apr 2021 18:40:57 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=PMA+2R/b8CKw1LzMqGxTXDaa73CT7T2QKTRh5d3HxbI=;
 b=gbcjMv9PBEpsk15HJ/sbPxeiHKX87w5UQRz2D5mxUFhj0EeN6dhcPVvnbVnd+0K8r8
 jeTN7ypsenQFJE1WnMzyMr+8U5fv74bLL+ky1eXgt6tCMPxaxuXGY0F9SNSjD7usOMJo
 X/832qn7IMnc7+mIHXcE5dHxG/OjLFtN2yiNVDxbSnr2hq8NVdUg1ZdDVvv+h8Hsk9h1
 GkSP8OAqHESpHXgqOIcrwEL2Zhmql4n3TrrG+VDKuBcqfqQmcTgMzCdX8dITLvZGZ1gL
 kWsGx9ypdVRTZez1piOQ+flJYVf++f0TQDw0iqeBBU1/2WOuw0SKRlkEZhZVjS2TTXU8
 qDKQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=PMA+2R/b8CKw1LzMqGxTXDaa73CT7T2QKTRh5d3HxbI=;
 b=d57sM47hJjpvF4G6spAxfZzaa/4sDG61LA1FlrxRsGUAxM2092JbMxKxvq30uiGweP
 dLBJ8T12O4YVTy684PvlLoAoysu9vtu5DNWeidp7go+i8RcUWgZ5GJpM3wNjAJEtGUEF
 qGF7QXs8s7omgfUhQGD8Jaujb0EX26trGWxjInIuwsb/BnR+j713iGboMdoDlZgr3C6y
 Qz5gLrG6f70f9tKjV3tM5wpNJzUUfyIzchYpNuawVkT6eWTY2rw8wehOq3DCYBj8h+8O
 6V3dZMnu+VhPbGNdCl9osLW/9b5AV9V5gT9aEqTUQkvTbfKJLzO9vhyGHqTdTzjrGvR0
 HzvQ==
X-Gm-Message-State: AOAM532eRbVHE1Kj8YmxS9aiaSX+W73y1nGDbDdnzE9mcIAgeiGaAC9N
 lpn4IfY3JcwQ9Xo9iiOmmsPdk4fLTmQ=
X-Google-Smtp-Source: ABdhPJzGVgABTCIE6jYXDKMvjYIXJJpEi3OsUvhouuAcmkApbC8RYq2Ol8BBQKh1o9R8cXYU0TZuAQ==
X-Received: by 2002:a5d:4751:: with SMTP id o17mr19878684wrs.219.1618018851554; 
 Fri, 09 Apr 2021 18:40:51 -0700 (PDT)
Received: from [192.168.0.6] ([46.251.119.176])
 by smtp.googlemail.com with ESMTPSA id g84sm5874220wmf.30.2021.04.09.18.40.50
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Fri, 09 Apr 2021 18:40:51 -0700 (PDT)
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Juri Linkov <juri@HIDDEN>
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
 <87o8eo38q9.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <7f1b570f-ea1b-5524-59fa-83bb5eaa9abd@HIDDEN>
Date: Sat, 10 Apr 2021 04:40:49 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
In-Reply-To: <87o8eo38q9.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47566-done
Cc: 47566-done <at> debbugs.gnu.org,
 Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 08.04.2021 21:57, Juri Linkov wrote:
> Thanks for the detailed test case.  Now it's fixed in 580c4c6510.

Thanks! repeat-mode is looking good now (*).

I've added integration for it to diff-hl master, and with that we can 
close this issue.

Thanks all.

(*) Though the first impression, in comparison, was that it is too 
chatty. The hints are definitely helpful for discovery at first, though.

Maybe something like this would be an improvement? Experimental code 
warning.

diff --git a/lisp/repeat.el b/lisp/repeat.el
index b3c58f2f81..e704e4da56 100644
--- a/lisp/repeat.el
+++ b/lisp/repeat.el
@@ -404,7 +404,7 @@ repeat-post-hook
                                         (key-description repeat-exit-key))
                               ""))))
                  (if (current-message)
-                    (message "%s [%s]" (current-message) mess)
+                    (message #("%s [%s]" 3 7 (face deemphasized)) 
(current-message) mess)
                    (message mess))))

              ;; Adding an exit key




Notification sent to Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Dmitry Gutov <dgutov@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 8 Apr 2021 18:57:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 08 14:57:50 2021
Received: from localhost ([127.0.0.1]:48343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lUZqg-0005Vw-Bg
	for submit <at> debbugs.gnu.org; Thu, 08 Apr 2021 14:57:50 -0400
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:59621)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lUZqe-0005Vi-88
 for 47566 <at> debbugs.gnu.org; Thu, 08 Apr 2021 14:57:49 -0400
X-Originating-IP: 91.129.107.223
Received: from mail.gandi.net (m91-129-107-223.cust.tele2.ee [91.129.107.223])
 (Authenticated sender: juri@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id 3CC2760003;
 Thu,  8 Apr 2021 18:57:39 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
 <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
Date: Thu, 08 Apr 2021 21:57:18 +0300
In-Reply-To: <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN> (Dmitry Gutov's
 message of "Wed, 7 Apr 2021 01:44:07 +0300")
Message-ID: <87o8eo38q9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566
Cc: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>, 47566 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> (defun hl-test ()
>   (interactive)
>   (message "OK")
>   (message "result: %s"
>            (y-or-n-p "Yes? ")))
>
> (defvar hl-repeat-map
>   (let ((map (make-sparse-keymap)))
>     (define-key map (kbd "n") 'hl-test) ; Note the changed key binding.
>     map)
>   "Keymap to repeat hl-test.")
>
> (put 'hl-test 'repeat-map 'hl-repeat-map)
>
> To try it:
>
> 1. M-x hl-test.
> 2. Press 'n' a few times.
>
> Expected behavior:
>
> It alternates between the prompt "Yes? " and message "result: nil".
>
> Actual behavior:
>
> It enters some sort of recursive state, only showing the prompt. I have to
> press 'y' a bunch of times to get out of it.

Thanks for the detailed test case.  Now it's fixed in 580c4c6510.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 6 Apr 2021 22:44:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 06 18:44:17 2021
Received: from localhost ([127.0.0.1]:42261 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lTuQj-00010s-Lf
	for submit <at> debbugs.gnu.org; Tue, 06 Apr 2021 18:44:17 -0400
Received: from mail-wm1-f49.google.com ([209.85.128.49]:39596)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1lTuQi-00010e-56
 for 47566 <at> debbugs.gnu.org; Tue, 06 Apr 2021 18:44:16 -0400
Received: by mail-wm1-f49.google.com with SMTP id
 g18-20020a7bc4d20000b0290116042cfdd8so142943wmk.4
 for <47566 <at> debbugs.gnu.org>; Tue, 06 Apr 2021 15:44:16 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=2AttC5npYv/gOj8u6ERdbvlf0+BYnvm0mZM+G+QZqGY=;
 b=SJSNCsJgVwN0iXgaKSGvtlmQ4keyz4C1ggtwDplab1yncBLEKrPOYb4QJdHzMbx1L1
 GXrjNr01FpnuK4i7/t86S+NGP4cJHuWBmFpmnW1BIzSFqLtzhu7s2rHmc/h7VdcOaxOv
 +Bv/ILQ6KGFQ+5kJHCVdGaXWT0uprR/z/UVCayGMnboo6v8uUvlXiFIErgj5lbY13xGK
 1pOTlSE55rzm77ooWY7D/388anDxpJ9hhfURbVOA8inYHgDVZlRAvmJZ+1kTKJyQ2F8a
 vbUWUoDyZvVWKjSHD+mNUqK8OX2gDQUOjY1UJZp3waUbwJL8aWooNXX+1tgu30E40q9+
 3EvQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=2AttC5npYv/gOj8u6ERdbvlf0+BYnvm0mZM+G+QZqGY=;
 b=sGMLovGQZSb+fP8efTExZVyNWaJxKU4l76Za+KMFCavo5gt9T1QGLpvYD6X8WHJeq7
 zo0+f3CFK2N8qE4x/DWrEqNy+gCXqdEOsui2/MylFm0U9IOtdZQNzKEHrPCREgbW4T0h
 06GHt96liF62PpGCAlXmawSFC97qZUvsakL6c670z7onO27qM6tl7tvCX1yoinxsee0c
 l0K1D8JbbRESbGxCNBeRMMOyt+74Q1WL1hjp5f37864UafPkGFzCN2637HULDdKV4s8e
 RQUnLf0sEalDz6VEkvnxqrpCy+BUe75ucUqni7NIHw4dsueAE8w7FBcZwpnWppbAX5jz
 DHIg==
X-Gm-Message-State: AOAM530JmJ0x6V6fcndeFuwSFNSn3YpF3qWJo/JT5T6gIOp6xd/ER1od
 N1nNjc10Emb5KMlAEOlATnZqxdlcYy4=
X-Google-Smtp-Source: ABdhPJxtjuIoHF63XwRCLIXhoy0/dnkYcwnoq6Gm9P0XZybUTWd8BLajBkDDYSvPsnDatraTA7T2Ew==
X-Received: by 2002:a1c:f605:: with SMTP id w5mr208372wmc.66.1617749050156;
 Tue, 06 Apr 2021 15:44:10 -0700 (PDT)
Received: from [192.168.0.6] ([46.251.119.176])
 by smtp.googlemail.com with ESMTPSA id l6sm33944764wrt.56.2021.04.06.15.44.08
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 06 Apr 2021 15:44:09 -0700 (PDT)
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Juri Linkov <juri@HIDDEN>
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
 <87pmz8lc17.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <9453a08f-5014-b4bc-8472-a4c2ff44c687@HIDDEN>
Date: Wed, 7 Apr 2021 01:44:07 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
In-Reply-To: <87pmz8lc17.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47566
Cc: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>, 47566 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Hi Juri,

On 05.04.2021 23:43, Juri Linkov wrote:
> Could you provide a minimal test case?  I tried with:
> 
> #+begin_src emacs-lisp
> (defun hl-test ()
>    (interactive)
>    (message "OK")
>    (y-or-n-p "Yes? "))
> 
> (defvar hl-repeat-map
>    (let ((map (make-sparse-keymap)))
>      (define-key map (kbd "r") 'hl-test)
>      map)
>    "Keymap to repeat hl-test.")
> (put 'hl-test 'repeat-map 'hl-repeat-map)
> #+end_src
> 
> Then typing `M-x hl-test RET', and `y r y r y r ...' keeps the loop.

Here you go:

(defun hl-test ()
   (interactive)
   (message "OK")
   (message "result: %s"
            (y-or-n-p "Yes? ")))

(defvar hl-repeat-map
   (let ((map (make-sparse-keymap)))
     (define-key map (kbd "n") 'hl-test) ; Note the changed key binding.
     map)
   "Keymap to repeat hl-test.")

(put 'hl-test 'repeat-map 'hl-repeat-map)

To try it:

1. M-x hl-test.
2. Press 'n' a few times.

Expected behavior:

It alternates between the prompt "Yes? " and message "result: nil".

Actual behavior:

It enters some sort of recursive state, only showing the prompt. I have 
to press 'y' a bunch of times to get out of it.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 5 Apr 2021 20:46:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 05 16:46:18 2021
Received: from localhost ([127.0.0.1]:38726 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lTW6z-0004qj-NT
	for submit <at> debbugs.gnu.org; Mon, 05 Apr 2021 16:46:17 -0400
Received: from relay12.mail.gandi.net ([217.70.178.232]:45547)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1lTW6y-0004qT-Km
 for 47566 <at> debbugs.gnu.org; Mon, 05 Apr 2021 16:46:17 -0400
Received: from mail.gandi.net (m91-129-107-223.cust.tele2.ee [91.129.107.223])
 (Authenticated sender: juri@HIDDEN)
 by relay12.mail.gandi.net (Postfix) with ESMTPSA id A9B5D200007;
 Mon,  5 Apr 2021 20:46:08 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and
 not `smartrep'
Organization: LINKOV.NET
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
 <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
Date: Mon, 05 Apr 2021 23:43:32 +0300
In-Reply-To: <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN> (Dmitry Gutov's
 message of "Sun, 4 Apr 2021 01:08:55 +0300")
Message-ID: <87pmz8lc17.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 47566
Cc: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>, 47566 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>>        (cl-loop for
>> 	       (cmd . key)
>> 	       in
>> 	       '((diff-hl-diff-goto-hunk . "=")
>> 		 (diff-hl-revert-hunk . "n")
>> 		 (diff-hl-previous-hunk . "[")
>> 		 (diff-hl-next-hunk . "]"))
>> 	       do
>> 	       (define-key diff-hl--repeat-map key cmd)
>> 	       (put cmd 'repeat-map 'diff-hl--repeat-map)))
>
> Try this alternative too, seems shorter:
>
> (map-keymap
>  (lambda (_key cmd)
>    (put cmd 'repeat-map 'diff-hl-command-map))
>  diff-hl-command-map)
>
> But either version (together with enabling repeat-mode) seems to break
> diff-hl-revert-hunk: as soon as it reaches the the y-or-n prompt, and I try
> to answer 'n', it enters the repeat loop again, instead of sending the
> result to the command.

Could you provide a minimal test case?  I tried with:

#+begin_src emacs-lisp
(defun hl-test ()
  (interactive)
  (message "OK")
  (y-or-n-p "Yes? "))

(defvar hl-repeat-map
  (let ((map (make-sparse-keymap)))
    (define-key map (kbd "r") 'hl-test)
    map)
  "Keymap to repeat hl-test.")
(put 'hl-test 'repeat-map 'hl-repeat-map)
#+end_src

Then typing `M-x hl-test RET', and `y r y r y r ...' keeps the loop.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at 47566 <at> debbugs.gnu.org:


Received: (at 47566) by debbugs.gnu.org; 3 Apr 2021 22:09:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Apr 03 18:09:05 2021
Received: from localhost ([127.0.0.1]:34533 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lSoS1-0000K2-F0
	for submit <at> debbugs.gnu.org; Sat, 03 Apr 2021 18:09:05 -0400
Received: from mail-wm1-f54.google.com ([209.85.128.54]:39861)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1lSoRz-0000JY-PT
 for 47566 <at> debbugs.gnu.org; Sat, 03 Apr 2021 18:09:04 -0400
Received: by mail-wm1-f54.google.com with SMTP id
 g18-20020a7bc4d20000b0290116042cfdd8so736300wmk.4
 for <47566 <at> debbugs.gnu.org>; Sat, 03 Apr 2021 15:09:03 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=kjs9Ge3ojuaoT7oFK7mldpwbA7dIaNlw16MILXQRr6g=;
 b=TUlOuhRUhMKpydNBvOR8o0+7Gar1Ykav0CE84PqBK7B9Nty5irLt3Vw5RQk+EJnn/+
 pGr2A9hnA36jDP/PKFOyaMwcZsEYy8ahYNFLw/pwPI5vOygtPiSBLzy+DdKZDDKFw3oH
 aCec/nhaTYYxDV49cQpn3WLrlGC46qh3FEDOKDfazb+yfllQzo613zRzABxjNJAhjCWK
 2z7VpYFe+PNkPpXCQnQlseITuporwdq0Gtptx1GHGz6PwXL4b0UFhsgisBQlDXJD8nS+
 dgaFkRl6o5j0HChz/Ob+Q6fKI3yJbDozarZRhTZgmT0b9tKBGHEfivSpa5mGsV5Zs0Fp
 0NzQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=kjs9Ge3ojuaoT7oFK7mldpwbA7dIaNlw16MILXQRr6g=;
 b=M0fRC9RmajgSiICiw5BDlRZjbQiMgSf3mFh4z62cYUpzOcIQ7d1WSXszW7MpBBRQ4Z
 TFly9PvmbWp7/c1xy6t7eEaN241uqs9muryy+5x5/2rFzRxKVggvk1IW2pqdMZGdkGNq
 AURuLsn5s3p/VVTTY18OpOlsScbi+nU25LbvdSMYHdaBYuKl/raaoiTdJMHdAAlbucR3
 3hQQpG4pBx2h8FBQEPkd2+LzGSYKm4IjvhMqY4X4qujd03Wb/DMwMsxDCYBEVT7newKN
 wTsxlFXM9CekHd0xG/5eVFM3sqpbKruH/09DWBCkk+TZG+c2hl35aZDPVo1j2D1jipj6
 q+zA==
X-Gm-Message-State: AOAM531TwJ17dr4lMlP9dlu0qfAekyZsyohYI8QO18K/IG9vrWTjPQWg
 hm7oU3TrVZXab6AoQlCQeOE=
X-Google-Smtp-Source: ABdhPJwALiJUVgBFjPEtnw07zWFl1bnqlNf/pWPWX1rQZ4UmxfL+SSIzVtF0V3cNajAKzPdtrFWu9A==
X-Received: by 2002:a1c:1b8b:: with SMTP id b133mr4515355wmb.147.1617487738040; 
 Sat, 03 Apr 2021 15:08:58 -0700 (PDT)
Received: from [192.168.0.6] ([46.251.119.176])
 by smtp.googlemail.com with ESMTPSA id u3sm20836229wrt.82.2021.04.03.15.08.56
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Sat, 03 Apr 2021 15:08:57 -0700 (PDT)
Subject: Re: bug#47566: 28.0.50; diff-hl should use `repeat-mode' ... and not
 `smartrep'
To: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>,
 47566 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
References: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <ca6238a3-8cd1-ea3d-54d6-5ae3ffdaec04@HIDDEN>
Date: Sun, 4 Apr 2021 01:08:55 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Thunderbird/78.7.1
MIME-Version: 1.0
In-Reply-To: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 47566
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Hi!

On 02.04.2021 08:40, Ramesh Nedunchezian wrote:
> FWIW, `smartrep' is not part of GNU Emacs or GNU ELPA but available
> elsewhere.  (I install it via MELPA)
> 
> Now, that `repeat-mode' is part of GNU Emacs, I think this dependency
> on `smartrep' can be removed.

I'd be happy to migrate away from smartrep, as soon as the functionality 
is equal, and all supported Emacs versions have repeat-mode.

> FWIW, this is what I have in my `.emacs'.
> 
>      (progn
>        (defvar diff-hl--repeat-map
> 	(let
> 	    ((map
> 	      (make-sparse-keymap)))
> 	  map))
>        (message "Installed %s" 'diff-hl--repeat-map)
>        (cl-loop for
> 	       (cmd . key)
> 	       in
> 	       '((diff-hl-diff-goto-hunk . "=")
> 		 (diff-hl-revert-hunk . "n")
> 		 (diff-hl-previous-hunk . "[")
> 		 (diff-hl-next-hunk . "]"))
> 	       do
> 	       (define-key diff-hl--repeat-map key cmd)
> 	       (put cmd 'repeat-map 'diff-hl--repeat-map)))

Try this alternative too, seems shorter:

(map-keymap
  (lambda (_key cmd)
    (put cmd 'repeat-map 'diff-hl-command-map))
  diff-hl-command-map)

But either version (together with enabling repeat-mode) seems to break 
diff-hl-revert-hunk: as soon as it reaches the the y-or-n prompt, and I 
try to answer 'n', it enters the repeat loop again, instead of sending 
the result to the command.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Apr 2021 14:50:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 02 10:50:58 2021
Received: from localhost ([127.0.0.1]:60870 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lSL8I-0000up-AD
	for submit <at> debbugs.gnu.org; Fri, 02 Apr 2021 10:50:58 -0400
Received: from lists.gnu.org ([209.51.188.17]:49846)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rameshnedunchezian@HIDDEN>) id 1lSCXv-0007cZ-Mw
 for submit <at> debbugs.gnu.org; Fri, 02 Apr 2021 01:40:40 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:40958)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rameshnedunchezian@HIDDEN>)
 id 1lSCXv-0006g8-Ep
 for bug-gnu-emacs@HIDDEN; Fri, 02 Apr 2021 01:40:39 -0400
Received: from mail-oln040092253027.outbound.protection.outlook.com
 ([40.92.253.27]:24829 helo=APC01-SG2-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rameshnedunchezian@HIDDEN>)
 id 1lSCXt-0006B7-1I
 for bug-gnu-emacs@HIDDEN; Fri, 02 Apr 2021 01:40:38 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=hd7AojeaWhx9EjvE79+Pvr9jzO4RQWd621EGNRtDq+d/02DxLzgMI6UP1PIiQpY+pFf1gw6aRS6hnqyPfJ1oF4e0UBqYYiKMWwuWYPCZYm6R3u0lGVcAxHXFiSwlTf9RDOizL+kkXMHK/7Y5sIHah0J148PPz++ys7CiecYK2AE3skazwxicO8U54uywBqk6ztsvaqs9TKluBrpXIAoksKjzVOw1A7/JI8rVILuxmILVx03O/Ak9MozBeclPjtlb0f7jJDZrLubSNH5qPt/8xDdLPGwm3XcbhgcdM8UCFMMQfaqI/KZsW65HriA5iEXv2XGaxVHhhtUmZFi4BsnW1A==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=bf/SWjqtgF8frIo3Y+CUno5G9zfz042A02PknvsI3TU=;
 b=ZqadbfbjgK6VEZcpCmQPsVSjSouWCgEmuRm6TZl13Z0MjzvCsGrijzH6bpGSzxL0CKevUnPuwUwFdaNpV44EfKI6B8GkaXAG4CWYr9ZEDqJXxFJfdi+jLUdW/oqAQR5/7yyK5K7qjLvGCjhwHt+rxGdNNsrzE6GMmgwNtkRZKtYCGEsC3cofQfwPCqpg0hrHDavsYo1PeMu8lhyifyDIYWNGnAsxsRnGSR8OEBYT+Aut3VIVEp7ftzPyhXrb071D0Jc+Q6gdSNvsj2t8puwbNsDaFWDbQjMHvjWBgVDSvZEspGMnzLdwLnM/1kB27QCfcAUr8NsjxowIEbZUO/qaDQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=bf/SWjqtgF8frIo3Y+CUno5G9zfz042A02PknvsI3TU=;
 b=nf3zXdIU66Nw8+vx6nmhApD8G0pUlr7mODYrURFXkn3M9wbJR5nLR7iPrUq1hQdXXy+6XknPoO1XBBDRYpZewfDIH+d4CbB20Wz7oh+NVicKhAAGQsS7LKyqRV5mJkGKbcnC9mMFX1wwXA85DkwK8NrXghMnXgn9Ov+lRmQ9qqtSYISpwHxX4MbXAu0cJr5Nt97pBWHE/M+uVM64457JoQDtgIEtoys2cdlM1yVJfEboIUFSLenuZ/zFwW2bYZ8nLrKhMNIf87McmMZxdbg76/daO7hkFxWrq/WxCUFlCKrZaEuDXfuZXN9R7kVv+EnzMUbBRm0CqVm0frpLfI02eQ==
Received: from TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 (2603:1096:404:800f::16) by TY2PR0101MB3118.apcprd01.prod.exchangelabs.com
 (2603:1096:404:e5::21) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3977.29; Fri, 2 Apr
 2021 05:40:25 +0000
Received: from TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 ([fe80::4980:4d7f:474b:de2c]) by
 TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 ([fe80::4980:4d7f:474b:de2c%3]) with mapi id 15.20.3999.029; Fri, 2 Apr 2021
 05:40:25 +0000
To: bug-gnu-emacs@HIDDEN
From: Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>
Subject: 28.0.50; diff-hl should use `repeat-mode' ... and not `smartrep'
Message-ID: <TY2PR0101MB36932D978661080B581457C6DA7A9@HIDDEN>
Date: Fri, 2 Apr 2021 11:10:13 +0530
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.5.0
Content-Type: text/plain; charset=utf-8
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-TMN: [9/hwbgWN3Vj4TGmdf0QOo2hr+PiJNeVh]
X-ClientProxiedBy: MAXPR0101CA0034.INDPRD01.PROD.OUTLOOK.COM
 (2603:1096:a00:d::20) To TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
 (2603:1096:404:800f::16)
X-Microsoft-Original-Message-ID: <25dc99d8-c9d3-f1da-a6af-1eac71c79210@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
Received: from [192.168.43.244] (117.230.15.35) by
 MAXPR0101CA0034.INDPRD01.PROD.OUTLOOK.COM (2603:1096:a00:d::20) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.3999.28 via Frontend
 Transport; Fri, 2 Apr 2021 05:40:23 +0000
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: 8e2f45d5-8063-4966-c09e-08d8f599d0a7
X-MS-TrafficTypeDiagnostic: TY2PR0101MB3118:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: V75CC3RXgc9OSgdg4f73R+SV3yNDji3eUypIGB7iIXXUQMz5yC1jqNtUxNgp542Oj/zgKnFFWnR9k1+QT2ZCfBcsyKKBHRNEGB+/kWQGM9a/6XtXBN6JfQJDtjO8cQRkdZDX7P1B5YUTkveXGxRPDar2nAgc2S92RG9JBqfEHcEYk8JVr9ZOo3K3HpjFchmU1nKNKOwc6SSMsCoVK91K98rTiq0T1KIVtNv86whkD4vtmVIZLG1KAjrNxogYR1jN8btZqRQajePmy8cjgQafmqu9UzxXFWwjE6YjJi2ZX46458MBGnLcUsx8zF4J3aTtmbUhMJDDb1nnymjGvw+ri37Aq/R7vZ4ygf/BGbj1F3OgYQY9CgRQPoS8E/HF3Kv7tqCz92vYrNkEaXJ812gSHw==
X-MS-Exchange-AntiSpam-MessageData: ToOgHpxo5hE/HslbB61ARRXG8Sn8LfTzJC2bQQgUKewLSWE+VusMB7V1zx6htz4p4m2qX0jL6gmgQUqti83fyzhBNdRqjjfI6nolNgZbmRCoF+HVLpqwUbJg2uA18Nc0wcrzNIkX+WTLLIa9/MlK+g==
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 8e2f45d5-8063-4966-c09e-08d8f599d0a7
X-MS-Exchange-CrossTenant-AuthSource: TY2PR0101MB3693.apcprd01.prod.exchangelabs.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 02 Apr 2021 05:40:25.6752 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: TY2PR0101MB3118
Received-SPF: pass client-ip=40.92.253.27;
 envelope-from=rameshnedunchezian@HIDDEN;
 helo=APC01-SG2-obe.outbound.protection.outlook.com
X-Spam_score_int: 2
X-Spam_score: 0.2
X-Spam_bar: /
X-Spam_report: (0.2 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1, DKIM_VALID=-0.1,
 DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FORGED_MUA_MOZILLA=2.309,
 FREEMAIL_FROM=0.001, MSGID_FROM_MTA_HEADER=0.001, RCVD_IN_DNSWL_NONE=-0.0001,
 RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  28.0.50;
 diff-hl should use `repeat-mode' ... and not `smartrep'.
 Commentary in `diff-hl' says ; ; `diff-hl-mode' highlights uncommitted changes
 on the side of the ;; window (using the fringe, by default), allows you to
 jump between ;; the hunks and revert them selectively. 
 Content analysis details:   (2.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (rameshnedunchezian[at]outlook.com)
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
 medium trust [209.51.188.17 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_H4      RBL: Very Good reputation (+4)
 [209.51.188.17 listed in wl.mailspike.net]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
 0.0 MSGID_FROM_MTA_HEADER  Message-Id was added by a relay
 1.6 FORGED_MUA_MOZILLA     Forged mail pretending to be from Mozilla
 1.9 SPOOFED_FREEMAIL       No description available.
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Fri, 02 Apr 2021 10:50:44 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  28.0.50; diff-hl should use `repeat-mode' ... and not `smartrep'.
    Commentary in `diff-hl' says ;; `diff-hl-mode' highlights uncommitted changes
    on the side of the ;; window (using the fringe, by default), allows you to
    jump between ;; the hunks and revert them selectively. 
 
 Content analysis details:   (1.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 T_SPF_HELO_TEMPERROR   SPF: test of HELO record failed (temperror)
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider
                             (rameshnedunchezian[at]outlook.com)
  1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.0 MSGID_FROM_MTA_HEADER  Message-Id was added by a relay
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
  1.6 FORGED_MUA_MOZILLA     Forged mail pretending to be from Mozilla


28.0.50; diff-hl should use `repeat-mode' ... and not `smartrep'.

Commentary in `diff-hl' says

    ;; `diff-hl-mode' highlights uncommitted changes on the side of the
    ;; window (using the fringe, by default), allows you to jump between
    ;; the hunks and revert them selectively.

    ;; Provided commands:
    ;;
    ;; `diff-hl-diff-goto-hunk'  C-x v =
    ;; `diff-hl-revert-hunk'     C-x v n
    ;; `diff-hl-previous-hunk'   C-x v [
    ;; `diff-hl-next-hunk'       C-x v ]
    ;;
    ;; The mode takes advantage of `smartrep' if it is installed.

FWIW, `smartrep' is not part of GNU Emacs or GNU ELPA but available
elsewhere.  (I install it via MELPA)

Now, that `repeat-mode' is part of GNU Emacs, I think this dependency
on `smartrep' can be removed.

FWIW, this is what I have in my `.emacs'.

    (progn
      (defvar diff-hl--repeat-map
	(let
	    ((map
	      (make-sparse-keymap)))
	  map))
      (message "Installed %s" 'diff-hl--repeat-map)
      (cl-loop for
	       (cmd . key)
	       in
	       '((diff-hl-diff-goto-hunk . "=")
		 (diff-hl-revert-hunk . "n")
		 (diff-hl-previous-hunk . "[")
		 (diff-hl-next-hunk . "]"))
	       do
	       (define-key diff-hl--repeat-map key cmd)
	       (put cmd 'repeat-map 'diff-hl--repeat-map)))

----------------

In GNU Emacs 28.0.50 (build 3, x86_64-pc-linux-gnu, GTK+ Version 3.24.24, cairo version 1.16.0)
 of 2021-03-20 built on debian
Repository revision: 31544bc908d35bff513450bc4bea1d0283a7ddb0
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12010000
System Description: Debian GNU/Linux bullseye/sid




Acknowledgement sent to Ramesh Nedunchezian <rameshnedunchezian@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#47566; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 14 Apr 2021 20:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.